<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates&#x2F;framework&#x2F;base&#x2F;icecap-sel4&#x2F;src&#x2F;debug.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>debug.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../icecap_sel4/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">sys</span>, <span class="ident">CPtr</span>, <span class="ident">LocalCPtr</span>, <span class="ident">TCB</span>};

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">debug_put_char</span>(<span class="ident">c</span>: <span class="ident">u8</span>) {
    <span class="kw">unsafe</span> { <span class="ident">sys::seL4_DebugPutChar</span>(<span class="ident">c</span>) }
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">debug_snapshot</span>() {
    <span class="kw">unsafe</span> { <span class="ident">sys::seL4_DebugSnapshot</span>() }
}

<span class="kw">impl</span> <span class="ident">TCB</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">debug_name</span>(<span class="self">self</span>, <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">name</span> <span class="op">=</span> <span class="ident">name</span>.<span class="ident">as_bytes</span>().<span class="ident">to_vec</span>();
        <span class="ident">name</span>.<span class="ident">push</span>(<span class="number">0</span>);
        <span class="kw">unsafe</span> { <span class="ident">sys::seL4_DebugNameThread</span>(<span class="self">self</span>.<span class="ident">raw</span>(), <span class="ident">name</span>.<span class="ident">as_ptr</span>()) }
    }
}

<span class="kw">impl</span> <span class="ident">CPtr</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">debug_identify</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u32</span> {
        <span class="kw">unsafe</span> { <span class="ident">sys::seL4_DebugCapIdentify</span>(<span class="self">self</span>.<span class="ident">raw</span>()) }
    }
}

<span class="comment">// generated in kernel:</span>
<span class="comment">// enum cap_tag {</span>
<span class="comment">//     cap_null_cap = 0,</span>
<span class="comment">//     cap_untyped_cap = 2,</span>
<span class="comment">//     cap_endpoint_cap = 4,</span>
<span class="comment">//     cap_notification_cap = 6,</span>
<span class="comment">//     cap_reply_cap = 8,</span>
<span class="comment">//     cap_cnode_cap = 10,</span>
<span class="comment">//     cap_thread_cap = 12,</span>
<span class="comment">//     cap_irq_control_cap = 14,</span>
<span class="comment">//     cap_irq_handler_cap = 16,</span>
<span class="comment">//     cap_zombie_cap = 18,</span>
<span class="comment">//     cap_domain_cap = 20,</span>
<span class="comment">//     cap_frame_cap = 1,</span>
<span class="comment">//     cap_page_table_cap = 3,</span>
<span class="comment">//     cap_page_directory_cap = 5,</span>
<span class="comment">//     cap_page_upper_directory_cap = 7,</span>
<span class="comment">//     cap_page_global_directory_cap = 9,</span>
<span class="comment">//     cap_asid_control_cap = 11,</span>
<span class="comment">//     cap_asid_pool_cap = 13,</span>
<span class="comment">//     cap_vcpu_cap = 15</span>
<span class="comment">// };</span>
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_sel4" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>